#!/usr/bin/perl
#
# This script generates a CSV File usable for MS Excel from
# test data. To convert . to , as expected by german versions
# of Excel pipe it's output through tr like this:
# ./ana-size-csv.pl |tr '.' ',' >out.csv

$|=1;

$SPEED=15;

$options[0]=[20 ,12,350];
$options[1]=[50 ,30,450];
$options[2]=[80 ,48,500];
$options[3]=[100,60,500];
$options[4]=[200,120,1600];

printf("Nodes;Routingamount;Ratio;PDF\r\n");

  foreach my $RP (qw(DSDV AODV AODVUU DSR TORA NRLOLSR)){
    print "\"$RP\"\r\n";
    foreach my $opt (@options){
			my $NODES = @{$opt}[0];
			my $CONS  = @{$opt}[1];
			my $SIZE  = @{$opt}[2];
			my $sent = 0;
			my $recv = 0;
			my $rtr_sz  = 0;
			my $rtr_szc = 0;
			my $rtr_szratio  =0;
			my $rtr_szratioc = 0;
      foreach my $RND (1111,5555,7777){
				my $cbr='out2/data/size-'.$SIZE.'-'.$RP.'-cbr-'.$NODES.'n-'.$CONS.'c-8.0r-50p-'.$RND.'rnd.data';
				my %vcbr=getdata($cbr);
				$sent += $vcbr{data_sent};
        $recv += $vcbr{data_recv};
				if($vcbr{rtr_size}){
					$rtr_sz += $vcbr{rtr_size};
					$rtr_szc++;
				}
				if($vcbr{rtr_szratio}){
          $rtr_szratio += $vcbr{rtr_szratio};
          $rtr_szratioc++;
        }
      }
      my $rtr_sz = ($rtr_sz/$rtr_szc);
			my $rtr_szratio = ($rtr_szratio/$rtr_szratioc);
			my $PDF = ($recv/$sent)*100; 
      printf("%d;%d;%.2f;%.2f\r\n",$NODES,$rtr_sz,$rtr_szratio,$PDF);
    }
    print "\n"
  }
  
sub getdata($){
  my $file = $_[0];
  my %data;

  open (FILE,$file) || die("argh $file");
  my @lines = <FILE>;
  close FILE;

  foreach $line (@lines){
    my ($key,$val) = split(':',$line,2);
                $key =~ s/\s+$//;
                $key =~ s/^\s+//;
                $val =~ s/\s+$//;
                $val =~ s/^\s+//;
                $data{$key}=$val;
  }
        return %data;
}
